/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Interface.xs. Do not edit this file, edit Interface.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Interface.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <stdio.h>
#include <stdlib.h>

#include "xdelta3.h"

// FIXME: figure out the right value for this: maybe dynamic?
#define BUF_SIZE 65536

#ifndef MIN
#define MIN(x,y) ((x)<(y)?(x):(y))
#endif

int encode_decode(int encode,
                  int source_fd, SV *source_sv,
                  int input_fd, SV *input_sv,
                  int output_fd, SV *output_sv) {
  int ret;
  ssize_t ssize_ret;
  int error = 0;
  xd3_stream stream;
  xd3_config config;
  xd3_source source;
  char *ibuf = NULL;
  int ibuf_len = 0;
  char *source_str = NULL;
  size_t source_str_size = 0;
  char *input_str = NULL;
  size_t input_str_size = 0;

  memset(&stream, 0, sizeof (stream));
  memset(&source, 0, sizeof (source));

  xd3_init_config(&config, 0);
  config.winsize = BUF_SIZE;
  if (xd3_config_stream(&stream, &config)) {
    // Nothing to clean up so just return error straight away
    return 1;
  }

  source.blksize = BUF_SIZE;
  source.curblkno = 0;

  if (source_fd != -1) {
    source.curblk = malloc(source.blksize);
    if (!source.curblk) {
      error = 2;
      goto bail;
    }
    if (lseek(source_fd, 0, SEEK_SET) < 0) {
      error = 3;
      goto bail;
    }
    ssize_ret = read(source_fd, (void*)source.curblk, source.blksize);
    if (ssize_ret < 0) {
      error = 4;
      goto bail;
    } else {
      source.onblk = (size_t) ssize_ret;
    }
  } else {
    source_str_size = SvCUR(source_sv);
    source_str = SvPV(source_sv, source_str_size);
    source.curblk = (uint8_t *) source_str;
    source.onblk = MIN(source.blksize, source_str_size);
  }

  xd3_set_source(&stream, &source);

  if (input_fd != -1) {
    ibuf = malloc(BUF_SIZE);
    if (!ibuf) {
      error = 5;
      goto bail;
    }
  } else {
    input_str_size = SvCUR(input_sv);
    input_str = SvPV(input_sv, input_str_size);
    ibuf = input_str;
    ibuf_len = 0;
  }

  do {
    if (input_fd != -1) {
      ibuf_len = read(input_fd, ibuf, BUF_SIZE);
      if (ibuf_len < 0) {
        error = 6;
        goto bail;
      }
    } else {
      ibuf += ibuf_len;
      ibuf_len = MIN(BUF_SIZE, input_str_size - (ibuf - input_str));
    }

    if (ibuf_len < BUF_SIZE) {
      xd3_set_flags(&stream, XD3_FLUSH | stream.flags);
    }
    xd3_avail_input(&stream, (uint8_t *) ibuf, ibuf_len);

process:
    if (encode)
      ret = xd3_encode_input(&stream);
    else
      ret = xd3_decode_input(&stream);

    switch (ret) {
      case XD3_INPUT:
        continue;

      case XD3_OUTPUT:
        if (output_fd != -1) {
          ssize_ret = write(output_fd, stream.next_out, stream.avail_out);
          if (ssize_ret < 0 || ((size_t)ssize_ret) != stream.avail_out) {
            error = 7;
            goto bail;
          }
        } else {
          sv_catpvn(output_sv, (char *) stream.next_out, stream.avail_out);
        }

        xd3_consume_output(&stream);

        goto process;

      case XD3_GETSRCBLK:
        source.curblkno = source.getblkno;

        if (source_fd != -1) {
          if (lseek(source_fd, source.blksize * source.getblkno, SEEK_SET) < 0) {
            error = 3;
            goto bail;
          }
          ssize_ret = read(source_fd, (void*)source.curblk, source.blksize);
          if (ssize_ret < 0) {
            error = 4;
            goto bail;
          } else {
            source.onblk = (size_t) ssize_ret;
          }
        } else {
          source.curblk = (uint8_t *) (source_str + (source.blksize * source.getblkno));
          source.onblk = MIN(source.blksize, source_str_size - (source.blksize * source.getblkno));
        }

        goto process;

      case XD3_GOTHEADER:
      case XD3_WINSTART:
      case XD3_WINFINISH:
        goto process;

      default:
        // These values start at -17703 and go down
        error = ret;
        goto bail;
    }

  } while (ibuf_len == BUF_SIZE);

bail:
  if (source_fd != -1 && source.curblk) {
    free((void*)source.curblk);
  }

  if (input_fd != -1 && ibuf) {
    free(ibuf);
  }

  if (xd3_close_stream(&stream) && !error) {
    error = 8;
  }
  xd3_free_stream(&stream);

  return error;
}



#line 192 "Interface.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 336 "Interface.c"

XS_EUPXS(XS_Vcdiff__Xdelta3__encode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Vcdiff__Xdelta3__encode)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "source_fd, source_sv, input_fd, input_sv, output_fd, output_sv");
    {
	int	source_fd = (int)SvIV(ST(0))
;
	SV *	source_sv = ST(1)
;
	int	input_fd = (int)SvIV(ST(2))
;
	SV *	input_sv = ST(3)
;
	int	output_fd = (int)SvIV(ST(4))
;
	SV *	output_sv = ST(5)
;
	int	RETVAL;
	dXSTARG;
#line 197 "Interface.xs"
        RETVAL = encode_decode(1,
                               source_fd, source_sv,
                               input_fd, input_sv,
                               output_fd, output_sv);

#line 365 "Interface.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Vcdiff__Xdelta3__decode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Vcdiff__Xdelta3__decode)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "source_fd, source_sv, input_fd, input_sv, output_fd, output_sv");
    {
	int	source_fd = (int)SvIV(ST(0))
;
	SV *	source_sv = ST(1)
;
	int	input_fd = (int)SvIV(ST(2))
;
	SV *	input_sv = ST(3)
;
	int	output_fd = (int)SvIV(ST(4))
;
	SV *	output_sv = ST(5)
;
	int	RETVAL;
	dXSTARG;
#line 216 "Interface.xs"
        RETVAL = encode_decode(0,
                               source_fd, source_sv,
                               input_fd, input_sv,
                               output_fd, output_sv);

#line 400 "Interface.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Vcdiff__Xdelta3); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Vcdiff__Xdelta3)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Vcdiff::Xdelta3::_encode", XS_Vcdiff__Xdelta3__encode, file, "$$$$$$");
        (void)newXSproto_portable("Vcdiff::Xdelta3::_decode", XS_Vcdiff__Xdelta3__decode, file, "$$$$$$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
